;=============================================================;
;         mmsystem.inc file for Easy Code visual IDE          ;
;            (made for the GoAsm compiler version)            ;
;                                                             ;
;         Version 1.0.00 (created on February, 2007)          ;
;                                                             ;
;      Please report any bug you find (asm@easycode.cat)      ;
;                                                             ;
;                Do not modify this file!!                    ;
;=============================================================;

#IFNDEF MMSYSTEM_INC
#Define MMSYSTEM_INC

#Define MAXPNAMELEN      			32
#Define MAXERRORLENGTH   			256
#Define MAX_JOYSTICKOEMVXDNAME		260

#IFNDEF MM_MIDI_MAPPER
	#Define MM_MIDI_MAPPER			1
	#Define MM_WAVE_MAPPER			2
	#Define MM_SNDBLST_MIDIOUT		3
	#Define MM_SNDBLST_MIDIIN		4
	#Define MM_SNDBLST_SYNTH		5
	#Define MM_SNDBLST_WAVEOUT		6
	#Define MM_SNDBLST_WAVEIN		7
	#Define MM_ADLIB				9
	#Define MM_MPU401_MIDIOUT		10
	#Define MM_MPU401_MIDIIN		11
	#Define MM_PC_JOYSTICK			12
#ENDIF

#Define MMVERSION					DD
#Define MMRESULT					DD

#Define TIME_MS						0001H
#Define TIME_SAMPLES				0002H
#Define TIME_BYTES					0004H
#Define TIME_SMPTE					0008H
#Define TIME_MIDI					0010H
#Define TIME_TICKS					0020H

#Define MM_JOY1MOVE					3A0H
#Define MM_JOY2MOVE					3A1H
#Define MM_JOY1ZMOVE				3A2H
#Define MM_JOY2ZMOVE				3A3H
#Define MM_JOY1BUTTONDOWN			3B5H
#Define MM_JOY2BUTTONDOWN			3B6H
#Define MM_JOY1BUTTONUP				3B7H
#Define MM_JOY2BUTTONUP				3B8H

#Define MM_MCINOTIFY				3B9H

#Define MM_WOM_OPEN					3BBH
#Define MM_WOM_CLOSE				3BCH
#Define MM_WOM_DONE					3BDH

#Define MM_WIM_OPEN					3BEH
#Define MM_WIM_CLOSE				3BFH
#Define MM_WIM_DATA					3C0H

#Define MM_MIM_OPEN					3C1H
#Define MM_MIM_CLOSE				3C2H
#Define MM_MIM_DATA					3C3H
#Define MM_MIM_LONGDATA				3C4H
#Define MM_MIM_ERROR				3C5H
#Define MM_MIM_LONGERROR			3C6H

#Define MM_MOM_OPEN					3C7H
#Define MM_MOM_CLOSE				3C8H
#Define MM_MOM_DONE					3C9H

#IFNDEF MM_DRVM_OPEN
	#Define MM_DRVM_OPEN			3D0H
	#Define MM_DRVM_CLOSE			3D1H
	#Define MM_DRVM_DATA			3D2H
	#Define MM_DRVM_ERROR			3D3H
#ENDIF

#Define MM_STREAM_OPEN				3D4H
#Define MM_STREAM_CLOSE				3D5H
#Define MM_STREAM_DONE				3D6H
#Define MM_STREAM_ERROR				3D7H

#IFNDEF MM_MCISIGNAL
	#Define MM_MCISIGNAL			3CBH
#ENDIF

#Define MM_MIM_MOREDATA				3CCH
#Define MM_MIXM_LINE_CHANGE			3D0H
#Define MM_MIXM_CONTROL_CHANGE		3D1H

#Define MMSYSERR_BASE				0
#Define WAVERR_BASE					32
#Define MIDIERR_BASE				64
#Define TIMERR_BASE					96
#Define JOYERR_BASE					160
#Define MCIERR_BASE					256
#Define MIXERR_BASE					1024
#Define MCI_STRING_OFFSET			512
#Define MCI_VD_OFFSET				1024
#Define MCI_CD_OFFSET				1088
#Define MCI_WAVE_OFFSET				1152
#Define MCI_SEQ_OFFSET				1216

#Define MMSYSERR_NOERROR			0
#Define MMSYSERR_ERROR				(MMSYSERR_BASE + 1)
#Define MMSYSERR_BADDEVICEID		(MMSYSERR_BASE + 2)
#Define MMSYSERR_NOTENABLED			(MMSYSERR_BASE + 3)
#Define MMSYSERR_ALLOCATED			(MMSYSERR_BASE + 4)
#Define MMSYSERR_INVALHANDLE		(MMSYSERR_BASE + 5)
#Define MMSYSERR_NODRIVER			(MMSYSERR_BASE + 6)
#Define MMSYSERR_NOMEM				(MMSYSERR_BASE + 7)
#Define MMSYSERR_NOTSUPPORTED		(MMSYSERR_BASE + 8)
#Define MMSYSERR_BADERRNUM			(MMSYSERR_BASE + 9)
#Define MMSYSERR_INVALFLAG			(MMSYSERR_BASE + 10)
#Define MMSYSERR_INVALPARAM			(MMSYSERR_BASE + 11)
#Define MMSYSERR_HANDLEBUSY			(MMSYSERR_BASE + 12)
#Define MMSYSERR_INVALIDALIAS		(MMSYSERR_BASE + 13)
#Define MMSYSERR_BADDB				(MMSYSERR_BASE + 14)
#Define MMSYSERR_KEYNOTFOUND		(MMSYSERR_BASE + 15)
#Define MMSYSERR_READERROR			(MMSYSERR_BASE + 16)
#Define MMSYSERR_WRITEERROR			(MMSYSERR_BASE + 17)
#Define MMSYSERR_DELETEERROR		(MMSYSERR_BASE + 18)
#Define MMSYSERR_VALNOTFOUND		(MMSYSERR_BASE + 19)
#Define MMSYSERR_NODRIVERCB			(MMSYSERR_BASE + 20)
#Define MMSYSERR_LASTERROR			(MMSYSERR_BASE + 20)

#IFNDEF DRV_LOAD
	#Define DRV_LOAD				0001H
	#Define DRV_ENABLE				0002H
	#Define DRV_OPEN				0003H
	#Define DRV_CLOSE				0004H
	#Define DRV_DISABLE				0005H
	#Define DRV_FREE				0006H
	#Define DRV_CONFIGURE			0007H
	#Define DRV_QUERYCONFIGURE		0008H
	#Define DRV_INSTALL				0009H
	#Define DRV_REMOVE				000AH
	#Define DRV_EXITSESSION			000BH
	#Define DRV_POWER				000FH
	#Define DRV_RESERVED			0800H
	#Define DRV_USER				4000H

	DRVCONFIGINFO Struct
		dwDCISize DD
		lpszDCISectionName DD
		lpszDCIAliasName DD
	EndS

	#Define DRVCNF_CANCEL			0000H
	#Define DRVCNF_OK				0001H
	#Define DRVCNF_RESTART			0002H

	#Define DefDriverProc 			DrvDefDriverProc
#ENDIF

#Define DRV_CANCEL					DRVCNF_CANCEL
#Define DRV_OK						DRVCNF_OK
#Define DRV_RESTART					DRVCNF_RESTART

#Define DRV_MCI_FIRST				DRV_RESERVED
#Define DRV_MCI_LAST				(DRV_RESERVED + 0FFFH)

#Define CALLBACK_TYPEMASK			00070000H
#Define CALLBACK_NULL				00000000H
#Define CALLBACK_WINDOW				00010000H
#Define CALLBACK_TASK				00020000H
#Define CALLBACK_FUNCTION			00030000H

#Define CALLBACK_THREAD				(CALLBACK_TASK)
#Define CALLBACK_EVENT				00050000H

#Define SND_SYNC					0000H
#Define SND_ASYNC					0001H
#Define SND_NODEFAULT				0002H
#Define SND_MEMORY					0004H
#Define SND_LOOP					0008H
#Define SND_NOSTOP					0010H

#Define SND_NOWAIT					00002000H
#Define SND_ALIAS					00010000H
#Define SND_ALIAS_ID				00110000H
#Define SND_FILENAME				00020000H
#Define SND_RESOURCE				00040004H

#Define SND_PURGE					0040H
#Define SND_APPLICATION				0080H

#Define SND_ALIAS_START				0

#Define WAVERR_BADFORMAT			(WAVERR_BASE + 0)
#Define WAVERR_STILLPLAYING			(WAVERR_BASE + 1)
#Define WAVERR_UNPREPARED			(WAVERR_BASE + 2)
#Define WAVERR_SYNC					(WAVERR_BASE + 3)
#Define WAVERR_LASTERROR			(WAVERR_BASE + 3)

#Define WOM_OPEN					MM_WOM_OPEN
#Define WOM_CLOSE					MM_WOM_CLOSE
#Define WOM_DONE					MM_WOM_DONE
#Define WIM_OPEN					MM_WIM_OPEN
#Define WIM_CLOSE					MM_WIM_CLOSE
#Define WIM_DATA					MM_WIM_DATA

#Define WAVE_MAPPER					-1

#Define WAVE_FORMAT_QUERY			0001H
#Define WAVE_ALLOWSYNC				0002H
#Define WAVE_MAPPED					0004H
#Define WAVE_FORMAT_DIRECT			0008H
#Define WAVE_FORMAT_DIRECT_QUERY	(WAVE_FORMAT_QUERY | WAVE_FORMAT_DIRECT)

#Define WHDR_DONE					00000001H
#Define WHDR_PREPARED				00000002H
#Define WHDR_BEGINLOOP				00000004H
#Define WHDR_ENDLOOP				00000008H
#Define WHDR_INQUEUE				00000010H

#Define WAVECAPS_PITCH				0001H
#Define WAVECAPS_PLAYBACKRATE		0002H
#Define WAVECAPS_VOLUME				0004H
#Define WAVECAPS_LRVOLUME			0008H
#Define WAVECAPS_SYNC				0010H
#Define WAVECAPS_SAMPLEACCURATE		0020H
#Define WAVECAPS_DIRECTSOUND		0040H

#Define WAVE_INVALIDFORMAT			00000000H
#Define WAVE_FORMAT_1M08			00000001H
#Define WAVE_FORMAT_1S08			00000002H
#Define WAVE_FORMAT_1M16			00000004H
#Define WAVE_FORMAT_1S16			00000008H
#Define WAVE_FORMAT_2M08			00000010H
#Define WAVE_FORMAT_2S08			00000020H
#Define WAVE_FORMAT_2M16			00000040H
#Define WAVE_FORMAT_2S16			00000080H
#Define WAVE_FORMAT_4M08			00000100H
#Define WAVE_FORMAT_4S08			00000200H
#Define WAVE_FORMAT_4M16			00000400H
#Define WAVE_FORMAT_4S16			00000800H

#Define WAVE_FORMAT_PCM				1

#Define MIDIERR_UNPREPARED			(MIDIERR_BASE + 0)
#Define MIDIERR_STILLPLAYING		(MIDIERR_BASE + 1)
#Define MIDIERR_NOMAP				(MIDIERR_BASE + 2)
#Define MIDIERR_NOTREADY			(MIDIERR_BASE + 3)
#Define MIDIERR_NODEVICE			(MIDIERR_BASE + 4)
#Define MIDIERR_INVALIDSETUP		(MIDIERR_BASE + 5)
#Define MIDIERR_BADOPENMODE			(MIDIERR_BASE + 6)
#Define MIDIERR_DONT_CONTINUE		(MIDIERR_BASE + 7)
#Define MIDIERR_LASTERROR			(MIDIERR_BASE + 7)

#Define MIM_OPEN					MM_MIM_OPEN
#Define MIM_CLOSE					MM_MIM_CLOSE
#Define MIM_DATA					MM_MIM_DATA
#Define MIM_LONGDATA				MM_MIM_LONGDATA
#Define MIM_ERROR					MM_MIM_ERROR
#Define MIM_LONGERROR				MM_MIM_LONGERROR
#Define MOM_OPEN					MM_MOM_OPEN
#Define MOM_CLOSE					MM_MOM_CLOSE
#Define MOM_DONE					MM_MOM_DONE
#Define MIM_MOREDATA				MM_MIM_MOREDATA
#Define MOM_POSITIONCB				MM_MOM_POSITIONCB

#Define MIDIMAPPER     				-1
#Define MIDI_MAPPER					-1

#Define MIDI_IO_STATUS				00000020H

#Define MIDI_CACHE_ALL				1
#Define MIDI_CACHE_BESTFIT			2
#Define MIDI_CACHE_QUERY			3
#Define MIDI_UNCACHE				4

#Define MOD_MIDIPORT				1
#Define MOD_SYNTH					2
#Define MOD_SQSYNTH					3
#Define MOD_FMSYNTH					4
#Define MOD_MAPPER					5

#Define MIDICAPS_VOLUME				0001H
#Define MIDICAPS_LRVOLUME			0002H
#Define MIDICAPS_CACHE				0004H
#Define MIDICAPS_STREAM				0008H

#Define MHDR_DONE					00000001H
#Define MHDR_PREPARED				00000002H
#Define MHDR_INQUEUE				00000004H
#Define MHDR_ISSTRM					00000008H

#Define MEVT_F_SHORT				00000000H
#Define MEVT_F_LONG					80000000H
#Define MEVT_F_CALLBACK				40000000H

#Define MEVT_SHORTMSG       		00H
#Define MEVT_TEMPO					01H
#Define MEVT_NOP					02H

#Define MEVT_LONGMSG				80H
#Define MEVT_COMMENT				82H
#Define MEVT_VERSION				84H

#define MIDISTRM_ERROR				-2

#Define MIDIPROP_SET				80000000H
#Define MIDIPROP_GET				40000000H

#Define MIDIPROP_TIMEDIV			00000001H
#Define MIDIPROP_TEMPO				00000002H

#Define AUX_MAPPER					-1

#Define AUXCAPS_CDAUDIO				1
#Define AUXCAPS_AUXIN				2

#Define AUXCAPS_VOLUME          	0001H
#Define AUXCAPS_LRVOLUME        	0002H

#Define MIXER_SHORT_NAME_CHARS   	16
#Define MIXER_LONG_NAME_CHARS    	64

#Define MIXERR_INVALLINE            (MIXERR_BASE + 0)
#define MIXERR_INVALCONTROL         (MIXERR_BASE + 1)
#define MIXERR_INVALVALUE           (MIXERR_BASE + 2)
#define MIXERR_LASTERROR            (MIXERR_BASE + 2)

#Define MIXER_OBJECTF_HANDLE		80000000H
#Define MIXER_OBJECTF_MIXER     	00000000H
#Define MIXER_OBJECTF_HMIXER    	(MIXER_OBJECTF_HANDLE | MIXER_OBJECTF_MIXER)
#Define MIXER_OBJECTF_WAVEOUT		10000000H
#Define MIXER_OBJECTF_HWAVEOUT		(MIXER_OBJECTF_HANDLE | MIXER_OBJECTF_WAVEOUT)
#Define MIXER_OBJECTF_WAVEIN		20000000H
#Define MIXER_OBJECTF_HWAVEIN		(MIXER_OBJECTF_HANDLE | MIXER_OBJECTF_WAVEIN)
#Define MIXER_OBJECTF_MIDIOUT		30000000H
#Define MIXER_OBJECTF_HMIDIOUT		(MIXER_OBJECTF_HANDLE | MIXER_OBJECTF_MIDIOUT)
#Define MIXER_OBJECTF_MIDIIN		40000000H
#Define MIXER_OBJECTF_HMIDIIN		(MIXER_OBJECTF_HANDLE | MIXER_OBJECTF_MIDIIN)
#Define MIXER_OBJECTF_AUX			50000000H

#Define MIXERLINE_LINEF_ACTIVE			00000001H
#Define MIXERLINE_LINEF_DISCONNECTED	00008000H
#Define MIXERLINE_LINEF_SOURCE			80000000H

#Define MIXERLINE_COMPONENTTYPE_DST_FIRST		00000000H
#Define MIXERLINE_COMPONENTTYPE_DST_UNDEFINED	(MIXERLINE_COMPONENTTYPE_DST_FIRST + 0)
#Define MIXERLINE_COMPONENTTYPE_DST_DIGITAL		(MIXERLINE_COMPONENTTYPE_DST_FIRST + 1)
#Define MIXERLINE_COMPONENTTYPE_DST_LINE		(MIXERLINE_COMPONENTTYPE_DST_FIRST + 2)
#Define MIXERLINE_COMPONENTTYPE_DST_MONITOR		(MIXERLINE_COMPONENTTYPE_DST_FIRST + 3)
#Define MIXERLINE_COMPONENTTYPE_DST_SPEAKERS	(MIXERLINE_COMPONENTTYPE_DST_FIRST + 4)
#Define MIXERLINE_COMPONENTTYPE_DST_HEADPHONES	(MIXERLINE_COMPONENTTYPE_DST_FIRST + 5)
#Define MIXERLINE_COMPONENTTYPE_DST_TELEPHONE	(MIXERLINE_COMPONENTTYPE_DST_FIRST + 6)
#Define MIXERLINE_COMPONENTTYPE_DST_WAVEIN		(MIXERLINE_COMPONENTTYPE_DST_FIRST + 7)
#Define MIXERLINE_COMPONENTTYPE_DST_VOICEIN		(MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)
#Define MIXERLINE_COMPONENTTYPE_DST_LAST		(MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)

#Define MIXERLINE_COMPONENTTYPE_SRC_FIRST		00001000H
#Define MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED	(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 0)
#Define MIXERLINE_COMPONENTTYPE_SRC_DIGITAL		(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 1)
#Define MIXERLINE_COMPONENTTYPE_SRC_LINE		(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 2)
#Define MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE	(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 3)
#Define MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER	(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4)
#Define MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC	(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 5)
#Define MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE	(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 6)
#Define MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER	(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 7)
#Define MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT		(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8)
#Define MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY	(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 9)
#Define MIXERLINE_COMPONENTTYPE_SRC_ANALOG		(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10)
#Define MIXERLINE_COMPONENTTYPE_SRC_LAST		(MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10)

#Define MIXERLINE_TARGETTYPE_UNDEFINED	0
#Define MIXERLINE_TARGETTYPE_WAVEOUT	1
#Define MIXERLINE_TARGETTYPE_WAVEIN		2
#Define MIXERLINE_TARGETTYPE_MIDIOUT	3
#Define MIXERLINE_TARGETTYPE_MIDIIN		4
#Define MIXERLINE_TARGETTYPE_AUX		5

#Define MIXER_GETLINEINFOF_DESTINATION		00000000H
#Define MIXER_GETLINEINFOF_SOURCE			00000001H
#Define MIXER_GETLINEINFOF_LINEID			00000002H
#Define MIXER_GETLINEINFOF_COMPONENTTYPE	00000003H
#Define MIXER_GETLINEINFOF_TARGETTYPE		00000004H

#Define MIXER_GETLINEINFOF_QUERYMASK		0000000FH

#Define MIXERCONTROL_CONTROLF_UNIFORM	00000001H
#Define MIXERCONTROL_CONTROLF_MULTIPLE	00000002H
#Define MIXERCONTROL_CONTROLF_DISABLED	80000000H

#Define MIXERCONTROL_CT_CLASS_MASK			0F0000000H
#Define MIXERCONTROL_CT_CLASS_CUSTOM		000000000H
#Define MIXERCONTROL_CT_CLASS_METER			010000000H
#Define MIXERCONTROL_CT_CLASS_SWITCH		020000000H
#Define MIXERCONTROL_CT_CLASS_NUMBER		030000000H
#Define MIXERCONTROL_CT_CLASS_SLIDER		040000000H
#Define MIXERCONTROL_CT_CLASS_FADER			050000000H
#Define MIXERCONTROL_CT_CLASS_TIME			060000000H
#Define MIXERCONTROL_CT_CLASS_LIST			070000000H

#Define MIXERCONTROL_CT_SUBCLASS_MASK		00F000000H

#Define MIXERCONTROL_CT_SC_SWITCH_BOOLEAN	000000000H
#Define MIXERCONTROL_CT_SC_SWITCH_BUTTON	001000000H

#Define MIXERCONTROL_CT_SC_METER_POLLED		000000000H

#Define MIXERCONTROL_CT_SC_TIME_MICROSECS	000000000H
#Define MIXERCONTROL_CT_SC_TIME_MILLISECS	001000000H

#Define MIXERCONTROL_CT_SC_LIST_SINGLE		000000000H
#Define MIXERCONTROL_CT_SC_LIST_MULTIPLE	001000000H

#Define MIXERCONTROL_CT_UNITS_MASK			000FF0000H
#Define MIXERCONTROL_CT_UNITS_CUSTOM		000000000H
#Define MIXERCONTROL_CT_UNITS_BOOLEAN		000010000H
#Define MIXERCONTROL_CT_UNITS_SIGNED		000020000H
#Define MIXERCONTROL_CT_UNITS_UNSIGNED		000030000H
#Define MIXERCONTROL_CT_UNITS_DECIBELS		000040000H
#Define MIXERCONTROL_CT_UNITS_PERCENT		000050000H

#Define MIXERCONTROL_CONTROLTYPE_CUSTOM			(MIXERCONTROL_CT_CLASS_CUSTOM | MIXERCONTROL_CT_UNITS_CUSTOM)
#Define MIXERCONTROL_CONTROLTYPE_BOOLEANMETER	(MIXERCONTROL_CT_CLASS_METER | MIXERCONTROL_CT_SC_METER_POLLED | MIXERCONTROL_CT_UNITS_BOOLEAN)
#Define MIXERCONTROL_CONTROLTYPE_SIGNEDMETER	(MIXERCONTROL_CT_CLASS_METER | MIXERCONTROL_CT_SC_METER_POLLED | MIXERCONTROL_CT_UNITS_SIGNED)
#Define MIXERCONTROL_CONTROLTYPE_PEAKMETER		(MIXERCONTROL_CONTROLTYPE_SIGNEDMETER + 1)
#Define MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER	(MIXERCONTROL_CT_CLASS_METER | MIXERCONTROL_CT_SC_METER_POLLED | MIXERCONTROL_CT_UNITS_UNSIGNED)
#Define MIXERCONTROL_CONTROLTYPE_BOOLEAN		(MIXERCONTROL_CT_CLASS_SWITCH | MIXERCONTROL_CT_SC_SWITCH_BOOLEAN | MIXERCONTROL_CT_UNITS_BOOLEAN)
#Define MIXERCONTROL_CONTROLTYPE_ONOFF			(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 1)
#Define MIXERCONTROL_CONTROLTYPE_MUTE			(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 2)
#Define MIXERCONTROL_CONTROLTYPE_MONO			(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 3)
#Define MIXERCONTROL_CONTROLTYPE_LOUDNESS		(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 4)
#Define MIXERCONTROL_CONTROLTYPE_STEREOENH		(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 5)
#Define MIXERCONTROL_CONTROLTYPE_BUTTON			(MIXERCONTROL_CT_CLASS_SWITCH | MIXERCONTROL_CT_SC_SWITCH_BUTTON | MIXERCONTROL_CT_UNITS_BOOLEAN)
#Define MIXERCONTROL_CONTROLTYPE_DECIBELS		(MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_DECIBELS)
#Define MIXERCONTROL_CONTROLTYPE_SIGNED			(MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_SIGNED)
#Define MIXERCONTROL_CONTROLTYPE_UNSIGNED		(MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_UNSIGNED)
#Define MIXERCONTROL_CONTROLTYPE_PERCENT		(MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_PERCENT)
#Define MIXERCONTROL_CONTROLTYPE_SLIDER			(MIXERCONTROL_CT_CLASS_SLIDER | MIXERCONTROL_CT_UNITS_SIGNED)
#Define MIXERCONTROL_CONTROLTYPE_PAN			(MIXERCONTROL_CONTROLTYPE_SLIDER + 1)
#Define MIXERCONTROL_CONTROLTYPE_QSOUNDPAN		(MIXERCONTROL_CONTROLTYPE_SLIDER + 2)
#Define MIXERCONTROL_CONTROLTYPE_FADER			(MIXERCONTROL_CT_CLASS_FADER | MIXERCONTROL_CT_UNITS_UNSIGNED)
#Define MIXERCONTROL_CONTROLTYPE_VOLUME			(MIXERCONTROL_CONTROLTYPE_FADER + 1)
#Define MIXERCONTROL_CONTROLTYPE_BASS			(MIXERCONTROL_CONTROLTYPE_FADER + 2)
#Define MIXERCONTROL_CONTROLTYPE_TREBLE			(MIXERCONTROL_CONTROLTYPE_FADER + 3)
#Define MIXERCONTROL_CONTROLTYPE_EQUALIZER		(MIXERCONTROL_CONTROLTYPE_FADER + 4)
#Define MIXERCONTROL_CONTROLTYPE_SINGLESELECT	(MIXERCONTROL_CT_CLASS_LIST | MIXERCONTROL_CT_SC_LIST_SINGLE | MIXERCONTROL_CT_UNITS_BOOLEAN)
#Define MIXERCONTROL_CONTROLTYPE_MUX			(MIXERCONTROL_CONTROLTYPE_SINGLESELECT + 1)
#Define MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT	(MIXERCONTROL_CT_CLASS_LIST | MIXERCONTROL_CT_SC_LIST_MULTIPLE | MIXERCONTROL_CT_UNITS_BOOLEAN)
#Define MIXERCONTROL_CONTROLTYPE_MIXER			(MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT + 1)
#Define MIXERCONTROL_CONTROLTYPE_MICROTIME		(MIXERCONTROL_CT_CLASS_TIME | MIXERCONTROL_CT_SC_TIME_MICROSECS | MIXERCONTROL_CT_UNITS_UNSIGNED)
#Define MIXERCONTROL_CONTROLTYPE_MILLITIME		(MIXERCONTROL_CT_CLASS_TIME | MIXERCONTROL_CT_SC_TIME_MILLISECS | MIXERCONTROL_CT_UNITS_UNSIGNED)

#Define MIXER_GETLINECONTROLSF_ALL			00000000H
#Define MIXER_GETLINECONTROLSF_ONEBYID		00000001H
#Define MIXER_GETLINECONTROLSF_ONEBYTYPE	00000002H

#Define MIXER_GETLINECONTROLSF_QUERYMASK	0000000FH

#Define MIXER_GETCONTROLDETAILSF_VALUE		00000000H
#Define MIXER_GETCONTROLDETAILSF_LISTTEXT	00000001H

#Define MIXER_GETCONTROLDETAILSF_QUERYMASK	0000000FH

#Define MIXER_SETCONTROLDETAILSF_VALUE		00000000H
#Define MIXER_SETCONTROLDETAILSF_CUSTOM		00000001H

#Define MIXER_SETCONTROLDETAILSF_QUERYMASK	0000000FH

#Define TIMERR_NOERROR				0
#Define TIMERR_NOCANDO				(TIMERR_BASE + 1)
#Define TIMERR_STRUCT				(TIMERR_BASE + 33)

#Define TIME_ONESHOT				0000H
#Define TIME_PERIODIC				0001H

#Define TIME_CALLBACK_FUNCTION		0000H
#Define TIME_CALLBACK_EVENT_SET		0010H
#Define TIME_CALLBACK_EVENT_PULSE	0020H

#Define JOYERR_NOERROR				0
#Define JOYERR_PARMS				(JOYERR_BASE + 5)
#Define JOYERR_NOCANDO				(JOYERR_BASE + 6)
#Define JOYERR_UNPLUGGED			(JOYERR_BASE + 7)

#Define JOY_BUTTON1					0001H
#Define JOY_BUTTON2					0002H
#Define JOY_BUTTON3					0004H
#Define JOY_BUTTON4					0008H
#Define JOY_BUTTON1CHG				0100H
#Define JOY_BUTTON2CHG				0200H
#Define JOY_BUTTON3CHG				0400H
#Define JOY_BUTTON4CHG				0800H

#Define JOY_BUTTON5					00000010H
#Define JOY_BUTTON6					00000020H
#Define JOY_BUTTON7					00000040H
#Define JOY_BUTTON8					00000080H
#Define JOY_BUTTON9					00000100H
#Define JOY_BUTTON10				00000200H
#Define JOY_BUTTON11				00000400H
#Define JOY_BUTTON12				00000800H
#Define JOY_BUTTON13				00001000H
#Define JOY_BUTTON14				00002000H
#Define JOY_BUTTON15				00004000H
#Define JOY_BUTTON16				00008000H
#Define JOY_BUTTON17				00010000H
#Define JOY_BUTTON18				00020000H
#Define JOY_BUTTON19				00040000H
#Define JOY_BUTTON20				00080000H
#Define JOY_BUTTON21				00100000H
#Define JOY_BUTTON22				00200000H
#Define JOY_BUTTON23				00400000H
#Define JOY_BUTTON24				00800000H
#Define JOY_BUTTON25				01000000H
#Define JOY_BUTTON26				02000000H
#Define JOY_BUTTON27				04000000H
#Define JOY_BUTTON28				08000000H
#Define JOY_BUTTON29				10000000H
#Define JOY_BUTTON30				20000000H
#Define JOY_BUTTON31				40000000H
#Define JOY_BUTTON32				80000000H

#define JOY_POVCENTERED				-1
#Define JOY_POVFORWARD				0
#Define JOY_POVRIGHT				9000
#Define JOY_POVBACKWARD				18000
#Define JOY_POVLEFT					27000

#Define JOY_RETURNX					00000001H
#Define JOY_RETURNY					00000002H
#Define JOY_RETURNZ					00000004H
#Define JOY_RETURNR					00000008H
#Define JOY_RETURNU					00000010H
#Define JOY_RETURNV					00000020H
#Define JOY_RETURNPOV				00000040H
#Define JOY_RETURNBUTTONS			00000080H
#Define JOY_RETURNRAWDATA			00000100H
#Define JOY_RETURNPOVCTS			00000200H
#Define JOY_RETURNCENTERED			00000400H
#Define JOY_USEDEADZONE				00000800H
#Define JOY_RETURNALL				(JOY_RETURNX | JOY_RETURNY | JOY_RETURNZ | JOY_RETURNR | JOY_RETURNU | JOY_RETURNV | JOY_RETURNPOV | JOY_RETURNBUTTONS)
#Define JOY_CAL_READALWAYS			00010000H
#Define JOY_CAL_READXYONLY			00020000H
#Define JOY_CAL_READ3				00040000H
#Define JOY_CAL_READ4				00080000H
#Define JOY_CAL_READXONLY			00100000H
#Define JOY_CAL_READYONLY			00200000H
#Define JOY_CAL_READ5				00400000H
#Define JOY_CAL_READ6				00800000H
#Define JOY_CAL_READZONLY			01000000H
#Define JOY_CAL_READRONLY			02000000H
#Define JOY_CAL_READUONLY			04000000H
#Define JOY_CAL_READVONLY			08000000H

#Define JOYSTICKID1					0
#Define JOYSTICKID2					1

#Define JOYCAPS_HASZ				0001H
#Define JOYCAPS_HASR				0002H
#Define JOYCAPS_HASU				0004H
#Define JOYCAPS_HASV				0008H
#Define JOYCAPS_HASPOV				0010H
#Define JOYCAPS_POV4DIR				0020H
#Define JOYCAPS_POVCTS				0040H

#Define MMIOERR_BASE				256
#Define MMIOERR_FILENOTFOUND		(MMIOERR_BASE + 1)
#Define MMIOERR_OUTOFMEMORY			(MMIOERR_BASE + 2)
#Define MMIOERR_CANNOTOPEN			(MMIOERR_BASE + 3)
#Define MMIOERR_CANNOTCLOSE			(MMIOERR_BASE + 4)
#Define MMIOERR_CANNOTREAD			(MMIOERR_BASE + 5)
#Define MMIOERR_CANNOTWRITE			(MMIOERR_BASE + 6)
#Define MMIOERR_CANNOTSEEK			(MMIOERR_BASE + 7)
#Define MMIOERR_CANNOTEXPAND		(MMIOERR_BASE + 8)
#Define MMIOERR_CHUNKNOTFOUND		(MMIOERR_BASE + 9)
#Define MMIOERR_UNBUFFERED			(MMIOERR_BASE + 10)
#Define MMIOERR_PATHNOTFOUND		(MMIOERR_BASE + 11)
#Define MMIOERR_ACCESSDENIED		(MMIOERR_BASE + 12)
#Define MMIOERR_SHARINGVIOLATION	(MMIOERR_BASE + 13)
#Define MMIOERR_NETWORKERROR		(MMIOERR_BASE + 14)
#Define MMIOERR_TOOMANYOPENFILES	(MMIOERR_BASE + 15)
#Define MMIOERR_INVALIDFILE			(MMIOERR_BASE + 16)

#Define CFSEPCHAR					'+'

#Define FOURCC						DD

#Define MMIO_RWMODE					00000003H
#Define MMIO_SHAREMODE				00000070H

#Define MMIO_CREATE					00001000H
#Define MMIO_PARSE					00000100H
#Define MMIO_DELETE					00000200H
#Define MMIO_EXIST					00004000H
#Define MMIO_ALLOCBUF				00010000H
#Define MMIO_GETTEMP				00020000H

#Define MMIO_DIRTY					10000000H

#Define MMIO_READ					00000000H
#Define MMIO_WRITE					00000001H
#Define MMIO_READWRITE				00000002H

#Define MMIO_COMPAT					00000000H
#Define MMIO_EXCLUSIVE				00000010H
#Define MMIO_DENYWRITE				00000020H
#Define MMIO_DENYREAD				00000030H
#Define MMIO_DENYNONE				00000040H

#Define MMIO_FHOPEN					0010H
#Define MMIO_EMPTYBUF				0010H
#Define MMIO_TOUPPER				0010H
#Define MMIO_INSTALLPROC			00010000H
#Define MMIO_GLOBALPROC				10000000H
#Define MMIO_REMOVEPROC				00020000H
#Define MMIO_UNICODEPROC			01000000H
#Define MMIO_FINDPROC				00040000H
#Define MMIO_FINDCHUNK				0010H
#Define MMIO_FINDRIFF				0020H
#Define MMIO_FINDLIST				0040H
#Define MMIO_CREATERIFF				0020H
#Define MMIO_CREATELIST				0040H

#Define MMIOM_READ					MMIO_READ
#Define MMIOM_WRITE					MMIO_WRITE
#Define MMIOM_SEEK					2
#Define MMIOM_OPEN					3
#Define MMIOM_CLOSE					4
#Define MMIOM_WRITEFLUSH			5

#Define MMIOM_RENAME				6

#Define FOURCC_RIFF					mmioFOURCC('R', 'I', 'F', 'F')
#Define FOURCC_LIST					mmioFOURCC('L', 'I', 'S', 'T')

#IFNDEF SEEK_SET
	#Define SEEK_SET				0
	#Define SEEK_CUR				1
	#Define SEEK_END				2
#ENDIF

#Define MMIO_DEFAULTBUFFER			8192

#Define MCIERROR					DD
#Define MCIDEVICEID					DD

#Define MCIERR_INVALID_DEVICE_ID		(MCIERR_BASE + 1)
#Define MCIERR_UNRECOGNIZED_KEYWORD		(MCIERR_BASE + 3)
#Define MCIERR_UNRECOGNIZED_COMMAND		(MCIERR_BASE + 5)
#Define MCIERR_HARDWARE					(MCIERR_BASE + 6)
#Define MCIERR_INVALID_DEVICE_NAME		(MCIERR_BASE + 7)
#Define MCIERR_OUT_OF_MEMORY			(MCIERR_BASE + 8)
#Define MCIERR_DEVICE_OPEN				(MCIERR_BASE + 9)
#Define MCIERR_CANNOT_LOAD_DRIVER		(MCIERR_BASE + 10)
#Define MCIERR_MISSING_COMMAND_STRING	(MCIERR_BASE + 11)
#Define MCIERR_PARAM_OVERFLOW			(MCIERR_BASE + 12)
#Define MCIERR_MISSING_STRING_ARGUMENT	(MCIERR_BASE + 13)
#Define MCIERR_BAD_INTEGER				(MCIERR_BASE + 14)
#Define MCIERR_PARSER_INTERNAL			(MCIERR_BASE + 15)
#Define MCIERR_DRIVER_INTERNAL			(MCIERR_BASE + 16)
#Define MCIERR_MISSING_PARAMETER		(MCIERR_BASE + 17)
#Define MCIERR_UNSUPPORTED_FUNCTION		(MCIERR_BASE + 18)
#Define MCIERR_FILE_NOT_FOUND			(MCIERR_BASE + 19)
#Define MCIERR_DEVICE_NOT_READY			(MCIERR_BASE + 20)
#Define MCIERR_INTERNAL					(MCIERR_BASE + 21)
#Define MCIERR_DRIVER					(MCIERR_BASE + 22)
#Define MCIERR_CANNOT_USE_ALL			(MCIERR_BASE + 23)
#Define MCIERR_MULTIPLE					(MCIERR_BASE + 24)
#Define MCIERR_EXTENSION_NOT_FOUND		(MCIERR_BASE + 25)
#Define MCIERR_OUTOFRANGE				(MCIERR_BASE + 26)
#Define MCIERR_FLAGS_NOT_COMPATIBLE		(MCIERR_BASE + 28)
#Define MCIERR_FILE_NOT_SAVED			(MCIERR_BASE + 30)
#Define MCIERR_DEVICE_TYPE_REQUIRED		(MCIERR_BASE + 31)
#Define MCIERR_DEVICE_LOCKED			(MCIERR_BASE + 32)
#Define MCIERR_DUPLICATE_ALIAS			(MCIERR_BASE + 33)
#Define MCIERR_BAD_CONSTANT				(MCIERR_BASE + 34)
#Define MCIERR_MUST_USE_SHAREABLE		(MCIERR_BASE + 35)
#Define MCIERR_MISSING_DEVICE_NAME		(MCIERR_BASE + 36)
#Define MCIERR_BAD_TIME_FORMAT			(MCIERR_BASE + 37)
#Define MCIERR_NO_CLOSING_QUOTE			(MCIERR_BASE + 38)
#Define MCIERR_DUPLICATE_FLAGS			(MCIERR_BASE + 39)
#Define MCIERR_INVALID_FILE				(MCIERR_BASE + 40)
#Define MCIERR_NULL_PARAMETER_BLOCK		(MCIERR_BASE + 41)
#Define MCIERR_UNNAMED_RESOURCE			(MCIERR_BASE + 42)
#Define MCIERR_NEW_REQUIRES_ALIAS		(MCIERR_BASE + 43)
#Define MCIERR_NOTIFY_ON_AUTO_OPEN		(MCIERR_BASE + 44)
#Define MCIERR_NO_ELEMENT_ALLOWED		(MCIERR_BASE + 45)
#Define MCIERR_NONAPPLICABLE_FUNCTION	(MCIERR_BASE + 46)
#Define MCIERR_ILLEGAL_FOR_AUTO_OPEN	(MCIERR_BASE + 47)
#Define MCIERR_FILENAME_REQUIRED		(MCIERR_BASE + 48)
#Define MCIERR_EXTRA_CHARACTERS			(MCIERR_BASE + 49)
#Define MCIERR_DEVICE_NOT_INSTALLED		(MCIERR_BASE + 50)
#Define MCIERR_GET_CD					(MCIERR_BASE + 51)
#Define MCIERR_SET_CD					(MCIERR_BASE + 52)
#Define MCIERR_SET_DRIVE				(MCIERR_BASE + 53)
#Define MCIERR_DEVICE_LENGTH			(MCIERR_BASE + 54)
#Define MCIERR_DEVICE_ORD_LENGTH		(MCIERR_BASE + 55)
#Define MCIERR_NO_INTEGER				(MCIERR_BASE + 56)

#Define MCIERR_WAVE_OUTPUTSINUSE		(MCIERR_BASE + 64)
#Define MCIERR_WAVE_SETOUTPUTINUSE		(MCIERR_BASE + 65)
#Define MCIERR_WAVE_INPUTSINUSE			(MCIERR_BASE + 66)
#Define MCIERR_WAVE_SETINPUTINUSE		(MCIERR_BASE + 67)
#Define MCIERR_WAVE_OUTPUTUNSPECIFIED	(MCIERR_BASE + 68)
#Define MCIERR_WAVE_INPUTUNSPECIFIED	(MCIERR_BASE + 69)
#Define MCIERR_WAVE_OUTPUTSUNSUITABLE	(MCIERR_BASE + 70)
#Define MCIERR_WAVE_SETOUTPUTUNSUITABLE	(MCIERR_BASE + 71)
#Define MCIERR_WAVE_INPUTSUNSUITABLE	(MCIERR_BASE + 72)
#Define MCIERR_WAVE_SETINPUTUNSUITABLE	(MCIERR_BASE + 73)

#Define MCIERR_SEQ_DIV_INCOMPATIBLE		(MCIERR_BASE + 80)
#Define MCIERR_SEQ_PORT_INUSE			(MCIERR_BASE + 81)
#Define MCIERR_SEQ_PORT_NONEXISTENT		(MCIERR_BASE + 82)
#Define MCIERR_SEQ_PORT_MAPNODEVICE		(MCIERR_BASE + 83)
#Define MCIERR_SEQ_PORT_MISCERROR		(MCIERR_BASE + 84)
#Define MCIERR_SEQ_TIMER				(MCIERR_BASE + 85)
#Define MCIERR_SEQ_PORTUNSPECIFIED		(MCIERR_BASE + 86)
#Define MCIERR_SEQ_NOMIDIPRESENT		(MCIERR_BASE + 87)

#Define MCIERR_NO_WINDOW				(MCIERR_BASE + 90)
#Define MCIERR_CREATEWINDOW				(MCIERR_BASE + 91)
#Define MCIERR_FILE_READ				(MCIERR_BASE + 92)
#Define MCIERR_FILE_WRITE				(MCIERR_BASE + 93)

#Define MCIERR_NO_IDENTITY				(MCIERR_BASE + 94)

#Define MCIERR_CUSTOM_DRIVER_BASE		(MCIERR_BASE + 256)

#Define MCI_FIRST						DRV_MCI_FIRST

#Define MCI_OPEN						0803H
#Define MCI_CLOSE						0804H
#Define MCI_ESCAPE						0805H
#Define MCI_PLAY						0806H
#Define MCI_SEEK						0807H
#Define MCI_STOP						0808H
#Define MCI_PAUSE						0809H
#Define MCI_INFO						080AH
#Define MCI_GETDEVCAPS					080BH
#Define MCI_SPIN						080CH
#Define MCI_SET							080DH
#Define MCI_STEP						080EH
#Define MCI_RECORD						080FH
#Define MCI_SYSINFO						0810H
#Define MCI_BREAK						0811H
#Define MCI_SAVE						0813H
#Define MCI_STATUS						0814H
#Define MCI_CUE							0830H
#Define MCI_REALIZE						0840H
#Define MCI_WINDOW						0841H
#Define MCI_PUT							0842H
#Define MCI_WHERE						0843H
#Define MCI_FREEZE						0844H
#Define MCI_UNFREEZE					0845H
#Define MCI_LOAD						0850H
#Define MCI_CUT							0851H
#Define MCI_COPY						0852H
#Define MCI_PASTE						0853H
#Define MCI_UPDATE						0854H
#Define MCI_RESUME						0855H
#Define MCI_DELETE						0856H

#Define MCI_USER_MESSAGES				(DRV_MCI_FIRST + 400H)
#Define MCI_LAST						0FFFH

#Define MCI_ALL_DEVICE_ID				(MCIDEVICEID - 1)

#Define MCI_DEVTYPE_VCR					513
#Define MCI_DEVTYPE_VIDEODISC			514
#Define MCI_DEVTYPE_OVERLAY				515
#Define MCI_DEVTYPE_CD_AUDIO			516
#Define MCI_DEVTYPE_DAT					517
#Define MCI_DEVTYPE_SCANNER				518
#Define MCI_DEVTYPE_ANIMATION			519
#Define MCI_DEVTYPE_DIGITAL_VIDEO		520
#Define MCI_DEVTYPE_OTHER				521
#Define MCI_DEVTYPE_WAVEFORM_AUDIO		522
#Define MCI_DEVTYPE_SEQUENCER			523

#Define MCI_DEVTYPE_FIRST				MCI_DEVTYPE_VCR
#Define MCI_DEVTYPE_LAST				MCI_DEVTYPE_SEQUENCER

#Define MCI_DEVTYPE_FIRST_USER			1000H
#Define MCI_MODE_NOT_READY				(MCI_STRING_OFFSET + 12)
#Define MCI_MODE_STOP					(MCI_STRING_OFFSET + 13)
#Define MCI_MODE_PLAY					(MCI_STRING_OFFSET + 14)
#Define MCI_MODE_RECORD					(MCI_STRING_OFFSET + 15)
#Define MCI_MODE_SEEK					(MCI_STRING_OFFSET + 16)
#Define MCI_MODE_PAUSE					(MCI_STRING_OFFSET + 17)
#Define MCI_MODE_OPEN					(MCI_STRING_OFFSET + 18)

#Define MCI_FORMAT_MILLISECONDS			0
#Define MCI_FORMAT_HMS					1
#Define MCI_FORMAT_MSF					2
#Define MCI_FORMAT_FRAMES				3
#Define MCI_FORMAT_SMPTE_24				4
#Define MCI_FORMAT_SMPTE_25				5
#Define MCI_FORMAT_SMPTE_30				6
#Define MCI_FORMAT_SMPTE_30DROP			7
#Define MCI_FORMAT_BYTES				8
#Define MCI_FORMAT_SAMPLES				9
#Define MCI_FORMAT_TMSF					10

#Define MCI_NOTIFY_SUCCESSFUL			0001H
#Define MCI_NOTIFY_SUPERSEDED			0002H
#Define MCI_NOTIFY_ABORTED				0004H
#Define MCI_NOTIFY_FAILURE				0008H

#Define MCI_NOTIFY						00000001H
#Define MCI_WAIT						00000002H
#Define MCI_FROM						00000004H
#Define MCI_TO							00000008H
#Define MCI_TRACK						00000010H

#Define MCI_OPEN_SHAREABLE				00000100H
#Define MCI_OPEN_ELEMENT				00000200H
#Define MCI_OPEN_ALIAS					00000400H
#Define MCI_OPEN_ELEMENT_ID				00000800H
#Define MCI_OPEN_TYPE_ID				00001000H
#Define MCI_OPEN_TYPE					00002000H

#Define MCI_SEEK_TO_START				00000100H
#Define MCI_SEEK_TO_END					00000200H

#Define MCI_STATUS_ITEM					00000100H
#Define MCI_STATUS_START				00000200H

#Define MCI_STATUS_LENGTH				00000001H
#Define MCI_STATUS_POSITION				00000002H
#Define MCI_STATUS_NUMBER_OF_TRACKS		00000003H
#Define MCI_STATUS_MODE					00000004H
#Define MCI_STATUS_MEDIA_PRESENT		00000005H
#Define MCI_STATUS_TIME_FORMAT			00000006H
#Define MCI_STATUS_READY				00000007H
#Define MCI_STATUS_CURRENT_TRACK		00000008H

#Define MCI_INFO_PRODUCT				00000100H
#Define MCI_INFO_FILE					00000200H
#Define MCI_INFO_MEDIA_UPC				00000400H
#Define MCI_INFO_MEDIA_IDENTITY			00000800H
#Define MCI_INFO_NAME					00001000H
#Define MCI_INFO_COPYRIGHT				00002000H

#Define MCI_GETDEVCAPS_ITEM				00000100H

#Define MCI_GETDEVCAPS_CAN_RECORD		00000001H
#Define MCI_GETDEVCAPS_HAS_AUDIO		00000002H
#Define MCI_GETDEVCAPS_HAS_VIDEO		00000003H
#Define MCI_GETDEVCAPS_DEVICE_TYPE		00000004H
#Define MCI_GETDEVCAPS_USES_FILES		00000005H
#Define MCI_GETDEVCAPS_COMPOUND_DEVICE	00000006H
#Define MCI_GETDEVCAPS_CAN_EJECT		00000007H
#Define MCI_GETDEVCAPS_CAN_PLAY			00000008H
#Define MCI_GETDEVCAPS_CAN_SAVE			00000009H

#Define MCI_SYSINFO_QUANTITY			00000100H
#Define MCI_SYSINFO_OPEN				00000200H
#Define MCI_SYSINFO_NAME				00000400H
#Define MCI_SYSINFO_INSTALLNAME			00000800H

#Define MCI_SET_DOOR_OPEN				00000100H
#Define MCI_SET_DOOR_CLOSED				00000200H
#Define MCI_SET_TIME_FORMAT				00000400H
#Define MCI_SET_AUDIO					00000800H
#Define MCI_SET_VIDEO					00001000H
#Define MCI_SET_ON						00002000H
#Define MCI_SET_OFF						00004000H

#Define MCI_SET_AUDIO_ALL				00000000H
#Define MCI_SET_AUDIO_LEFT				00000001H
#Define MCI_SET_AUDIO_RIGHT				00000002H

#Define MCI_BREAK_KEY					00000100H
#Define MCI_BREAK_HWND					00000200H
#Define MCI_BREAK_OFF					00000400H

#Define MCI_RECORD_INSERT				00000100H
#Define MCI_RECORD_OVERWRITE			00000200H

#Define MCI_SAVE_FILE					00000100H

#Define MCI_LOAD_FILE					00000100H

#Define MCI_VD_MODE_PARK				(MCI_VD_OFFSET + 1)

#Define MCI_VD_MEDIA_CLV				(MCI_VD_OFFSET + 2)
#Define MCI_VD_MEDIA_CAV				(MCI_VD_OFFSET + 3)
#Define MCI_VD_MEDIA_OTHER				(MCI_VD_OFFSET + 4)

#Define MCI_VD_FORMAT_TRACK				4001H

#Define MCI_VD_PLAY_REVERSE				00010000H
#Define MCI_VD_PLAY_FAST				00020000H
#Define MCI_VD_PLAY_SPEED				00040000H
#Define MCI_VD_PLAY_SCAN				00080000H
#Define MCI_VD_PLAY_SLOW				00100000H

#Define MCI_VD_SEEK_REVERSE				00010000H

#Define MCI_VD_STATUS_SPEED				00004002H
#Define MCI_VD_STATUS_FORWARD			00004003H
#Define MCI_VD_STATUS_MEDIA_TYPE		00004004H
#Define MCI_VD_STATUS_SIDE				00004005H
#Define MCI_VD_STATUS_DISC_SIZE			00004006H

#Define MCI_VD_GETDEVCAPS_CLV			00010000H
#Define MCI_VD_GETDEVCAPS_CAV			00020000H

#Define MCI_VD_SPIN_UP					00010000H
#Define MCI_VD_SPIN_DOWN				00020000H

#Define MCI_VD_GETDEVCAPS_CAN_REVERSE	00004002H
#Define MCI_VD_GETDEVCAPS_FAST_RATE		00004003H
#Define MCI_VD_GETDEVCAPS_SLOW_RATE		00004004H
#Define MCI_VD_GETDEVCAPS_NORMAL_RATE	00004005H

#Define MCI_VD_STEP_FRAMES				00010000H
#Define MCI_VD_STEP_REVERSE				00020000H

#Define MCI_VD_ESCAPE_STRING			00000100H

#Define MCI_CDA_STATUS_TYPE_TRACK		00004001H

#Define MCI_CDA_TRACK_AUDIO				(MCI_CD_OFFSET + 0)
#Define MCI_CDA_TRACK_OTHER				(MCI_CD_OFFSET + 1)

#Define MCI_WAVE_PCM					(MCI_WAVE_OFFSET + 0)
#Define MCI_WAVE_MAPPER					(MCI_WAVE_OFFSET + 1)

#Define MCI_WAVE_OPEN_BUFFER			00010000H

#Define MCI_WAVE_SET_FORMATTAG			00010000H
#Define MCI_WAVE_SET_CHANNELS			00020000H
#Define MCI_WAVE_SET_SAMPLESPERSEC		00040000H
#Define MCI_WAVE_SET_AVGBYTESPERSEC		00080000H
#Define MCI_WAVE_SET_BLOCKALIGN			00100000H
#Define MCI_WAVE_SET_BITSPERSAMPLE		00200000H

#Define MCI_WAVE_INPUT					00400000H
#Define MCI_WAVE_OUTPUT					00800000H

#Define MCI_WAVE_STATUS_FORMATTAG		00004001H
#Define MCI_WAVE_STATUS_CHANNELS		00004002H
#Define MCI_WAVE_STATUS_SAMPLESPERSEC	00004003H
#Define MCI_WAVE_STATUS_AVGBYTESPERSEC	00004004H
#Define MCI_WAVE_STATUS_BLOCKALIGN		00004005H
#Define MCI_WAVE_STATUS_BITSPERSAMPLE	00004006H
#Define MCI_WAVE_STATUS_LEVEL			00004007H

#Define MCI_WAVE_SET_ANYINPUT			04000000H
#Define MCI_WAVE_SET_ANYOUTPUT			08000000H

#Define MCI_WAVE_GETDEVCAPS_INPUTS		00004001H
#Define MCI_WAVE_GETDEVCAPS_OUTPUTS		00004002H

#Define MCI_SEQ_DIV_PPQN				(0 + MCI_SEQ_OFFSET)
#Define MCI_SEQ_DIV_SMPTE_24			(1 + MCI_SEQ_OFFSET)
#Define MCI_SEQ_DIV_SMPTE_25			(2 + MCI_SEQ_OFFSET)
#Define MCI_SEQ_DIV_SMPTE_30DROP		(3 + MCI_SEQ_OFFSET)
#Define MCI_SEQ_DIV_SMPTE_30			(4 + MCI_SEQ_OFFSET)

#Define MCI_SEQ_FORMAT_SONGPTR			4001H
#Define MCI_SEQ_FILE					4002H
#Define MCI_SEQ_MIDI					4003H
#Define MCI_SEQ_SMPTE					4004H
#Define MCI_SEQ_NONE					65533
#Define MCI_SEQ_MAPPER					65535

#Define MCI_SEQ_STATUS_TEMPO			00004002H
#Define MCI_SEQ_STATUS_PORT				00004003H
#Define MCI_SEQ_STATUS_SLAVE			00004007H
#Define MCI_SEQ_STATUS_MASTER			00004008H
#Define MCI_SEQ_STATUS_OFFSET			00004009H
#Define MCI_SEQ_STATUS_DIVTYPE			0000400AH
#Define MCI_SEQ_STATUS_NAME				0000400BH
#Define MCI_SEQ_STATUS_COPYRIGHT		0000400CH

#Define MCI_SEQ_SET_TEMPO				00010000H
#Define MCI_SEQ_SET_PORT				00020000H
#Define MCI_SEQ_SET_SLAVE				00040000H
#Define MCI_SEQ_SET_MASTER				00080000H
#Define MCI_SEQ_SET_OFFSET				01000000H

#Define MCI_ANIM_OPEN_WS				00010000H
#Define MCI_ANIM_OPEN_PARENT			00020000H
#Define MCI_ANIM_OPEN_NOSTATIC			00040000H

#Define MCI_ANIM_PLAY_SPEED				00010000H
#Define MCI_ANIM_PLAY_REVERSE			00020000H
#Define MCI_ANIM_PLAY_FAST				00040000H
#Define MCI_ANIM_PLAY_SLOW				00080000H
#Define MCI_ANIM_PLAY_SCAN				00100000H

#Define MCI_ANIM_STEP_REVERSE			00010000H
#Define MCI_ANIM_STEP_FRAMES			00020000H

#Define MCI_ANIM_STATUS_SPEED			00004001H
#Define MCI_ANIM_STATUS_FORWARD			00004002H
#Define MCI_ANIM_STATUS_HWND			00004003H
#Define MCI_ANIM_STATUS_HPAL			00004004H
#Define MCI_ANIM_STATUS_STRETCH			00004005H

#Define MCI_ANIM_INFO_TEXT				00010000H

#Define MCI_ANIM_GETDEVCAPS_CAN_REVERSE	00004001H
#Define MCI_ANIM_GETDEVCAPS_FAST_RATE	00004002H
#Define MCI_ANIM_GETDEVCAPS_SLOW_RATE	00004003H
#Define MCI_ANIM_GETDEVCAPS_NORMAL_RATE	00004004H
#Define MCI_ANIM_GETDEVCAPS_PALETTES	00004006H
#Define MCI_ANIM_GETDEVCAPS_CAN_STRETCH	00004007H
#Define MCI_ANIM_GETDEVCAPS_MAX_WINDOWS	00004008H

#Define MCI_ANIM_REALIZE_NORM			00010000H
#Define MCI_ANIM_REALIZE_BKGD			00020000H

#Define MCI_ANIM_WINDOW_HWND			00010000H
#Define MCI_ANIM_WINDOW_STATE			00040000H
#Define MCI_ANIM_WINDOW_TEXT			00080000H
#Define MCI_ANIM_WINDOW_ENABLE_STRETCH	00100000H
#Define MCI_ANIM_WINDOW_DISABLE_STRETCH	00200000H

#Define MCI_ANIM_WINDOW_DEFAULT			00000000H

#Define MCI_ANIM_RECT					00010000H
#Define MCI_ANIM_PUT_SOURCE				00020000H
#Define MCI_ANIM_PUT_DESTINATION		00040000H

#Define MCI_ANIM_WHERE_SOURCE			00020000H
#Define MCI_ANIM_WHERE_DESTINATION		00040000H

#Define MCI_ANIM_UPDATE_HDC				00020000H

#Define MCI_OVLY_OPEN_WS				00010000H
#Define MCI_OVLY_OPEN_PARENT			00020000H

#Define MCI_OVLY_STATUS_HWND			00004001H
#Define MCI_OVLY_STATUS_STRETCH			00004002H

#Define MCI_OVLY_INFO_TEXT				00010000H

#Define MCI_OVLY_GETDEVCAPS_CAN_STRETCH	00004001H
#Define MCI_OVLY_GETDEVCAPS_CAN_FREEZE	00004002H
#Define MCI_OVLY_GETDEVCAPS_MAX_WINDOWS	00004003H

#Define MCI_OVLY_WINDOW_HWND			00010000H
#Define MCI_OVLY_WINDOW_STATE			00040000H
#Define MCI_OVLY_WINDOW_TEXT			00080000H
#Define MCI_OVLY_WINDOW_ENABLE_STRETCH	00100000H
#Define MCI_OVLY_WINDOW_DISABLE_STRETCH	00200000H

#Define MCI_OVLY_WINDOW_DEFAULT			00000000H

#Define MCI_OVLY_RECT					00010000H
#Define MCI_OVLY_PUT_SOURCE				00020000H
#Define MCI_OVLY_PUT_DESTINATION		00040000H
#Define MCI_OVLY_PUT_FRAME				00080000H
#Define MCI_OVLY_PUT_VIDEO				00100000H

#Define MCI_OVLY_WHERE_SOURCE			00020000H
#Define MCI_OVLY_WHERE_DESTINATION		00040000H
#Define MCI_OVLY_WHERE_FRAME			00080000H
#Define MCI_OVLY_WHERE_VIDEO			00100000H

#IFNDEF NEWTRANSPARENT
	#Define NEWTRANSPARENT				3
	#Define QUERYROPSUPPORT				40
#ENDIF

#Define SELECTDIB						41

#IFNDEF SC_SCREENSAVE
	#Define SC_SCREENSAVE				0F140H
#ENDIF


smpte Struct
	hour DB
 	minute DB
 	sec DB
 	Frame DB
	fps DB
	dummy DB
	pad DB 2 Dup ?
EndS

midi Struct
	songptrpos DD
EndS

MMUNION Union
	ms DD
	sample DD
	cb DD
	ticks DD
	smp smpte
	midi1 midi
EndUnion

MMTIME Struct
	wType DD
	u MMUNION <>
EndS

DRVCONFIGINFOEX Struct
	dwDCISize DD
	lpszDCISectionName DD
	lpszDCIAliasName DD
	dnDevNode DD
EndS

WAVEHDR Struct
	lpData DD
	dwBufferLength DD
	dwBytesRecorded DD
	dwUser DD
	dwFlags DD
	dwLoops DD
	lpNext DD
	Reserved DD
EndS

WAVEOUTCAPSA Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DB MAXPNAMELEN Dup ?
	dwFormats DD
	wChannels DW
	wReserved1 DW
	dwSupport DD
EndS

WAVEOUTCAPSW Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DW MAXPNAMELEN Dup ?
	dwFormats DD
	wChannels DW
	wReserved1 DW
	dwSupport DD
EndS

WAVEINCAPSA Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DB MAXPNAMELEN Dup ?
	dwFormats DD
	wChannels DW
	wReserved1 DW
EndS

WAVEINCAPSW Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DW MAXPNAMELEN Dup ?
	dwFormats DD
	wChannels DW
	wReserved1 DW
EndS

WAVEFORMAT Struct
	wFormatTag DW
	nChannels DW
	nSamplesPerSec DD
	nAvgBytesPerSec DD
	nBlockAlign DW
EndS

PCMWAVEFORMAT Struct
	wf WAVEFORMAT
	wBitsPerSample DW
EndS

WAVEFORMATEX Struct
	wFormatTag DW
	nChannels DW
	nSamplesPerSec DD
	nAvgBytesPerSec DD
	nBlockAlign DW
	wBitsPerSample DW
	cbSize DW
EndS

MIDIOUTCAPSA Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname	DB MAXPNAMELEN Dup ?
	wTechnology DW
	wVoices DW
	wNotes DW
	wChannelMask DW
	dwSupport DD
EndS

MIDIOUTCAPSW Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname	DW MAXPNAMELEN Dup ?
	wTechnology DW
	wVoices DW
	wNotes DW
	wChannelMask DW
	dwSupport DD
EndS

MIDIINCAPSA Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DB MAXPNAMELEN Dup ?
	dwSupport DD
EndS

MIDIINCAPSW Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DW MAXPNAMELEN Dup ?
	dwSupport DD
EndS

MIDIHDR Struct
	lpData DD
	dwBufferLength DD
	dwBytesRecorded DD
	dwUser DD
	dwFlags DD
	lpNext DD
	reserved DD
	dwOffset DD
	dwReserved DD 8 Dup ?
EndS

MIDIEVENT Struct
	dwDeltaTime DD
	dwStreamID DD
	dwEvent DD
	dwParms DD
EndS

MIDISTRMBUFFVER Struct
	dwVersion DD
	dwMid DD
	dwOEMVersion DD
EndS

MIDIPROPTIMEDIV Struct
	cbStruct DD
	dwTimeDiv DD
EndS

MIDIPROPTEMPO Struct
	cbStruct DD
	dwTempo DD
EndS

AUXCAPSA strcut
	wMid DW
	wPid DW
    MMVERSION vDriverVersion
	szPname DB MAXPNAMELEN Dup ?
	wTechnology DW
	wReserved1 DW
	dwSupport DD
EndS

AUXCAPSW strcut
	wMid DW
	wPid DW
    MMVERSION vDriverVersion
	szPname DW MAXPNAMELEN Dup ?
	wTechnology DW
	wReserved1 DW
	dwSupport DD
EndS

MIXERCAPSA Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DB MAXPNAMELEN Dup ?
	fdwSupport DD
	cDestinations DD
EndS

MIXERCAPSW Struct
	wMid DW
	wPid DW
	vDriverVersion MMVERSION
	szPname DW MAXPNAMELEN Dup ?
	fdwSupport DD
	cDestinations DD
EndS

MIXERLINEA Struct
	cbStruct DD
	dwDestination DD
	dwSource DD
	dwLineID DD
	fdwLine DD
	dwUser DD
	dwComponentType DD
	cChannels DD
	cConnections DD
	cControls DD
	szShortName DB MIXER_SHORT_NAME_CHARS Dup ?
	szName DB MIXER_LONG_NAME_CHARS Dup ?
	Target Struct
		dwType DD
		dwDeviceID DD
		wMid DW
		wPid DW
		vDriverVersion MMVERSION
		szPname DB MAXPNAMELEN Dup ?
	EndS
EndS

MIXERLINEW Struct
	cbStruct DD
	dwDestination DD
	dwSource DD
	dwLineID DD
	fdwLine DD
	dwUser DD
	dwComponentType DD
	cChannels DD
	cConnections DD
	cControls DD
	szShortName DW MIXER_SHORT_NAME_CHARS Dup ?
	szName DW MIXER_LONG_NAME_CHARS Dup ?
	Target Struct
		dwType DD
		dwDeviceID DD
		wMid DW
		wPid DW
		vDriverVersion MMVERSION
		szPname DW MAXPNAMELEN Dup ?
	EndS
EndS

MIXERCONTROLA Struct
	cbStruct DD
	dwControlID DD
	dwControlType DD
	fdwControl DD
	cMultipleItems DD
	szShortName DB MIXER_SHORT_NAME_CHARS Dup ?
	szName DB MIXER_LONG_NAME_CHARS Dup ?
	Union ;Bounds
		Struct
			lMinimum DD
			lMaximum DD
		EndS
		Struct
			dwMinimum DD
			dwMaximum DD
		EndS
		dwReserved DD 6 Dup ?
    EndUnion
	Union ;Metrics
		cSteps DD
		cbCustomData DD
		dwReserved DD 6 Dup ?
	EndUnion
EndS

MIXERCONTROLW Struct
	cbStruct DD
	dwControlID DD
	dwControlType DD
	fdwControl DD
	cMultipleItems DD
	szShortName DW MIXER_SHORT_NAME_CHARS Dup ?
	szName DW MIXER_LONG_NAME_CHARS Dup ?
    Union ;Bounds
		Struct
			lMinimum DD
			lMaximum DD
		EndS
		Struct
			dwMinimum DD
			dwMaximum DD
		EndS
		dwReserved DD 6 Dup ?
    EndUnion
	Union ;Metrics
	cSteps DD
	cbCustomData DD
	dwReserved DD 6 Dup ?
	EndUnion
EndS

MIXERLINECONTROLSA Struct
	cbStruct DD
	dwLineID DD
	Union
		dwControlID DD
		dwControlType DD
  	EndUnion
	cControls DD
	cbmxctrl DD
	pamxctrl DD
EndS

MIXERLINECONTROLSW Struct
	cbStruct DD
	dwLineID DD
	Union
		dwControlID DD
		dwControlType DD
  	EndUnion
	cControls DD
	cbmxctrl DD
	pamxctrl DD
EndS

MIXERCONTROLDETAILS Struct
	cbStruct DD
	dwControlID DD
	cChannels DD
	Union
		hwndOwner DD
		cMultipleItems DD
	EndUnion
	cbDetails DD
	paDetails DD
EndS

MIXERCONTROLDETAILS_LISTTEXTA Struct
	dwParam1 DD
	dwParam2 DD
	szName DB MIXER_LONG_NAME_CHARS Dup ?
EndS

MIXERCONTROLDETAILS_LISTTEXTW Struct
	dwParam1 DD
	dwParam2 DD
	szName DW MIXER_LONG_NAME_CHARS Dup ?
EndS

MIXERCONTROLDETAILS_BOOLEAN Struct
	fValue DD
EndS

MIXERCONTROLDETAILS_SIGNED Struct
	lValue DD
EndS

MIXERCONTROLDETAILS_UNSIGNED Struct
	dwValue DD
EndS

TIMECAPS Struct
	wPeriodMin DD
	wPeriodMax DD
EndS

JOYCAPSA Struct
	wMid DW
	wPid DW
	szPname DB MAXPNAMELEN Dup ?
	wXmin DD
	wXmax DD
	wYmin DD
	wYmax DD
	wZmin DD
	wZmax DD
	wNumButtons DD
	wPeriodMin DD
	wPeriodMax DD
	wRmin DD
	wRmax DD
	wUmin DD
	wUmax DD
	wVmin DD
	wVmax DD
	wCaps DD
	wMaxAxes DD
	wNumAxes DD
	wMaxButtons DD
	szRegKey DB MAXPNAMELEN Dup ?
	szOEMVxD DB MAX_JOYSTICKOEMVXDNAME Dup ?
EndS

JOYCAPSW Struct
	wMid DW
	wPid DW
	szPname DW MAXPNAMELEN Dup ?
	wXmin DD
	wXmax DD
	wYmin DD
	wYmax DD
	wZmin DD
	wZmax DD
	wNumButtons DD
	wPeriodMin DD
	wPeriodMax DD
	wRmin DD
	wRmax DD
	wUmin DD
	wUmax DD
	wVmin DD
	wVmax DD
	wCaps DD
	wMaxAxes DD
	wNumAxes DD
	wMaxButtons DD
	szRegKey DW MAXPNAMELEN Dup ?
	szOEMVxD DW MAX_JOYSTICKOEMVXDNAME Dup ?
EndS

JOYINFO Struct
	wXpos DD
	wYpos DD
	wZpos DD
	wButtons DD
EndS

JOYINFOEX Struct
	dwSize DD
	dwFlags DD
	dwXpos DD
	dwYpos DD
	dwZpos DD
	dwRpos DD
	dwUpos DD
	dwVpos DD
	dwButtons DD
	dwButtonNumber DD
	dwPOV DD
	dwReserved1 DD
	dwReserved2 DD
EndS

MMIOINFO Struct
	dwFlags DD
	fccIOProc DD
	pIOProc DD
	wErrorRet DD
	htask DD
	cchBuffer DD
	pchBuffer DD
	pchNext DD
	pchEndRead DD
	pchEndWrite DD
	lBufOffset DD
	lDiskOffset DD
	adwInfo DD 3 Dup ?
	dwReserved1 DD
	dwReserved2 DD
	hmmio DD
EndS

MMCKINFO Struct
	ckid DD
	ckSize DD
	fccType DD
	dwDataOffset DD
	dwFlags DD
EndS

MCI_GENERIC_PARMS Struct
	dwCallback DD
EndS

MCI_OPEN_PARMSA Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
EndS

MCI_OPEN_PARMSW Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
EndS

MCI_PLAY_PARMS Struct
	dwCallback DD
	dwFrom DD
	dwTo DD
EndS

MCI_SEEK_PARMS Struct
	dwCallback DD
	dwTo DD
EndS

MCI_STATUS_PARMS Struct
	dwCallback DD
	dwReturn DD
	dwItem DD
	dwTrack DD
EndS

MCI_INFO_PARMSA Struct
	dwCallback DD
	lpstrReturn DD
	dwRetSize DD
EndS

MCI_INFO_PARMSW Struct
	dwCallback DD
	lpstrReturn DD
	dwRetSize DD
EndS

MCI_GETDEVCAPS_PARMS Struct
	dwCallback DD
	dwReturn DD
	dwItem DD
EndS

MCI_SYSINFO_PARMSA Struct
	dwCallback DD
	lpstrReturn DD
	dwRetSize DD
	dwNumber DD
	wDeviceType DD
EndS

MCI_SYSINFO_PARMSW Struct
	dwCallback DD
	lpstrReturn DD
	dwRetSize DD
	dwNumber DD
	wDeviceType DD
EndS

MCI_SET_PARMS Struct
	dwCallback DD
	dwTimeFormat DD
	dwAudio DD
EndS

MCI_BREAK_PARMS Struct
	dwCallback DD
	nVirtKey DD
	hwndBreak DD
EndS

MCI_SAVE_PARMSA Struct
	dwCallback DD
	lpfilename DD
EndS

MCI_SAVE_PARMSW Struct
	dwCallback DD
	lpfilename DD
EndS

MCI_LOAD_PARMSA Struct
	dwCallback DD
	lpfilename DD
EndS

MCI_LOAD_PARMSW Struct
	dwCallback DD
	lpfilename DD
EndS

MCI_RECORD_PARMSA Struct
	dwCallback DD
	dwFrom DD
	dwTo DD
EndS

MCI_RECORD_PARMSW Struct
	dwCallback DD
	dwFrom DD
	dwTo DD
EndS

MCI_VD_PLAY_PARMS Struct
	dwCallback DD
	dwFrom DD
	dwTo DD
	dwSpeed DD
EndS

MCI_VD_STEP_PARMS Struct
	dwCallback DD
	dwFrames DD
EndS

MCI_VD_ESCAPE_PARMSA Struct
	dwCallback DD
	lpstrCommand DD
EndS

MCI_VD_ESCAPE_PARMSW Struct
	dwCallback DD
	lpstrCommand DD
EndS

MCI_WAVE_OPEN_PARMSA Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
	dwBufferSeconds DD
EndS

MCI_WAVE_OPEN_PARMSW Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
	dwBufferSeconds DD
EndS

MCI_WAVE_DELETE_PARMS Struct
	dwCallback DD
	dwFrom DD
	dwTo DD
EndS

MCI_WAVE_SET_PARMS Struct
	dwCallback DD
	dwTimeFormat DD
	dwAudio DD
	wInput  DD
	wOutput  DD
	wFormatTag DW
	wReserved2 DW
	nChannels DW
	wReserved3 DW
	nSamplesPerSec DD
	nAvgBytesPerSec DD
	nBlockAlign DW
	wReserved4 DW
	wBitsPerSample DW
	wReserved5 DW
EndS

MCI_SEQ_SET_PARMS Struct
	dwCallback DD
	dwTimeFormat DD
	dwAudio DD
	dwTempo DD
	dwPort DD
	dwSlave DD
	dwMaster DD
	dwOffset DD
EndS

MCI_ANIM_OPEN_PARMSA Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
	dwStyle DD
	hWndParent DD
EndS

MCI_ANIM_OPEN_PARMSW Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
	dwStyle DD
	hWndParent DD
EndS

MCI_ANIM_PLAY_PARMS Struct
	dwCallback DD
	dwFrom DD
	dwTo DD
	dwSpeed DD
EndS

MCI_ANIM_STEP_PARMS Struct
	dwCallback DD
	dwFrames DD
EndS

MCI_ANIM_WINDOW_PARMSA Struct
	dwCallback DD
	hWnd DD
	nCmdShow DD
	lpstrText DD
EndS

MCI_ANIM_WINDOW_PARMSW Struct
	dwCallback DD
	hWnd DD
	nCmdShow DD
	lpstrText DD
EndS

MCI_ANIM_RECT_PARMS Struct
	dwCallback DD
	rc RECT <>
EndS

MCI_ANIM_UPDATE_PARMS Struct
	dwCallback DD
	rc RECT <>
	hDC DD
EndS

MCI_OVLY_OPEN_PARMSA Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
	dwStyle DD
	hWndParent DD
EndS

MCI_OVLY_OPEN_PARMSW Struct
	dwCallback DD
	wDeviceID DD
	lpstrDeviceType DD
	lpstrElementName DD
	lpstrAlias DD
	dwStyle DD
	hWndParent DD
EndS

MCI_OVLY_WINDOW_PARMSA Struct
	dwCallback DD
	hWnd DD
	nCmdShow DD
	lpstrText DD
EndS

MCI_OVLY_WINDOW_PARMSW Struct
	dwCallback DD
	hWnd DD
	nCmdShow DD
	lpstrText DD
EndS

MCI_OVLY_RECT_PARMS Struct
	dwCallback DD
	rc RECT <>
EndS

MCI_OVLY_SAVE_PARMSA Struct
	dwCallback DD
	lpfilename DD
	rc RECT <>
EndS

MCI_OVLY_SAVE_PARMSW Struct
	dwCallback DD
	lpfilename DD
	rc RECT <>
EndS

MCI_OVLY_LOAD_PARMSA Struct
	dwCallback DD
	lpfilename DD
	rc RECT <>
EndS

MCI_OVLY_LOAD_PARMSW Struct
	dwCallback DD
	lpfilename DD
	rc RECT <>
EndS


#IF STRINGS UNICODE
	#Define PlaySound PlaySoundW
	#Define WAVEOUTCAPS WAVEOUTCAPSW
	#Define WAVEINCAPS WAVEINCAPSW
	#Define waveOutGetDevCaps waveOutGetDevCapsW
	#Define waveOutGetErrorText waveOutGetErrorTextW
	#Define MIDIOUTCAPS MIDIOUTCAPSW
	#Define MIDIINCAPS MIDIINCAPSW
	#Define midiOutGetDevCaps midiOutGetDevCapsW
	#Define midiOutGetErrorText midiOutGetErrorTextW
	#Define midiInGetDevCaps midiInGetDevCapsW
	#Define midiInGetErrorText midiInGetErrorTextW
	#Define AUXCAPS AUXCAPSW
	#Define auxGetDevCaps auxGetDevCapsW
	#Define MIXERCAPS MIXERCAPSW
	#Define mixerGetDevCaps mixerGetDevCapsW
	#Define MIXERLINE MIXERLINEW
	#Define mixerGetLineInfo mixerGetLineInfoW
	#Define MIXERCONTROL MIXERCONTROLW
	#Define MIXERLINECONTROLS MIXERLINECONTROLSW
	#Define mixerGetLineControls mixerGetLineControlsW
	#Define MIXERCONTROLDETAILS_LISTTEXT MIXERCONTROLDETAILS_LISTTEXTW
	#Define mixerGetControlDetails mixerGetControlDetailsW
	#Define JOYCAPS JOYCAPSW
	#Define joyGetDevCaps joyGetDevCapsW
	#Define mmioStringToFOURCC mmioStringToFOURCCW
	#Define mmioInstallIOProc mmioInstallIOProcW
	#Define mmioOpen mmioOpenW
	#Define mmioRename mmioRenameW
	#Define mciSendCommand mciSendCommandW
	#Define mciSendString mciSendStringW
	#Define mciGetDeviceID mciGetDeviceIDW
	#Define mciGetDeviceIDFromElementID mciGetDeviceIDFromElementIDW
	#Define mciGetErrorString mciGetErrorStringW
	#Define MCI_OPEN_PARMS MCI_OPEN_PARMSW
	#Define MCI_INFO_PARMS MCI_INFO_PARMSW
	#Define MCI_SYSINFO_PARMS MCI_SYSINFO_PARMSW
	#Define MCI_SAVE_PARMS MCI_SAVE_PARMSW
	#Define MCI_LOAD_PARMS MCI_LOAD_PARMSW
	#Define MCI_RECORD_PARMS MCI_RECORD_PARMSW
	#Define MCI_VD_ESCAPE_PARMS MCI_VD_ESCAPE_PARMSW
	#Define MCI_WAVE_OPEN_PARMS MCI_WAVE_OPEN_PARMSW
	#Define MCI_ANIM_OPEN_PARMS MCI_ANIM_OPEN_PARMSW
	#Define MCI_ANIM_WINDOW_PARMS MCI_ANIM_WINDOW_PARMSW
	#Define MCI_OVLY_OPEN_PARMS MCI_OVLY_OPEN_PARMSW
	#Define MCI_OVLY_WINDOW_PARMS MCI_OVLY_WINDOW_PARMSW
	#Define MCI_OVLY_SAVE_PARMS MCI_OVLY_SAVE_PARMSW
	#Define MCI_OVLY_LOAD_PARMS MCI_OVLY_LOAD_PARMSW
#ELSE
	#Define PlaySound PlaySoundA
	#Define WAVEOUTCAPS WAVEOUTCAPSA
	#Define WAVEINCAPS WAVEINCAPSA
	#Define waveOutGetDevCaps waveOutGetDevCapsA
	#Define waveOutGetErrorText waveOutGetErrorTextA
	#Define MIDIOUTCAPS MIDIOUTCAPSA
	#Define MIDIINCAPS MIDIINCAPSA
	#Define midiOutGetDevCaps midiOutGetDevCapsA
	#Define midiOutGetErrorText midiOutGetErrorTextA
	#Define midiInGetDevCaps midiInGetDevCapsA
	#Define midiInGetErrorText midiInGetErrorTextA
	#Define AUXCAPS AUXCAPSA
	#Define auxGetDevCaps auxGetDevCapsA
	#Define MIXERCAPS MIXERCAPSA
	#Define mixerGetDevCaps mixerGetDevCapsA
	#Define MIXERLINE MIXERLINEA
	#Define mixerGetLineInfo mixerGetLineInfoA
	#Define MIXERCONTROL MIXERCONTROLA
	#Define MIXERLINECONTROLS MIXERLINECONTROLSA
	#Define mixerGetLineControls mixerGetLineControlsA
	#Define MIXERCONTROLDETAILS_LISTTEXT MIXERCONTROLDETAILS_LISTTEXTA
	#Define mixerGetControlDetails mixerGetControlDetailsA
	#Define JOYCAPS JOYCAPSA
	#Define joyGetDevCaps joyGetDevCapsA
	#Define mmioStringToFOURCC mmioStringToFOURCCA
	#Define mmioInstallIOProc mmioInstallIOProcA
	#Define mmioOpen mmioOpenA
	#Define mmioRename mmioRenameA
	#Define mciSendCommand mciSendCommandA
	#Define mciSendString mciSendStringA
	#Define mciGetDeviceID mciGetDeviceIDA
	#Define mciGetDeviceIDFromElementID mciGetDeviceIDFromElementIDA
	#Define mciGetErrorString mciGetErrorStringA
	#Define MCI_OPEN_PARMS MCI_OPEN_PARMSA
	#Define MCI_INFO_PARMS MCI_INFO_PARMSA
	#Define MCI_SYSINFO_PARMS MCI_SYSINFO_PARMSA
	#Define MCI_SAVE_PARMS MCI_SAVE_PARMSA
	#Define MCI_LOAD_PARMS MCI_LOAD_PARMSA
	#Define MCI_RECORD_PARMS MCI_RECORD_PARMSA
	#Define MCI_VD_ESCAPE_PARMS MCI_VD_ESCAPE_PARMSA
	#Define MCI_WAVE_OPEN_PARMS MCI_WAVE_OPEN_PARMSA
	#Define MCI_ANIM_OPEN_PARMS MCI_ANIM_OPEN_PARMSA
	#Define MCI_ANIM_WINDOW_PARMS MCI_ANIM_WINDOW_PARMSA
	#Define MCI_OVLY_OPEN_PARMS MCI_OVLY_OPEN_PARMSA
	#Define MCI_OVLY_WINDOW_PARMS MCI_OVLY_WINDOW_PARMSA
	#Define MCI_OVLY_SAVE_PARMS MCI_OVLY_SAVE_PARMSA
	#Define MCI_OVLY_LOAD_PARMS MCI_OVLY_LOAD_PARMSA
#ENDIF

#ENDIF ;MMSYSTEM_INC
