;=============================================================;
;          winperf.inc file for Easy Code visual IDE          ;
;            (made for the GoAsm compiler version)            ;
;                                                             ;
;         Version 1.0.00 (created on February, 2007)          ;
;                                                             ;
;      Please report any bug you find (asm@easycode.cat)      ;
;                                                             ;
;                Do not modify this file!!                    ;
;=============================================================;

#IFNDEF WINPERF_INC
#Define WINPERF_INC

#Define PERF_DATA_VERSION   				1
#Define PERF_DATA_REVISION  				1

#Define PERF_SIZE_DWORD         			000000000H
#Define PERF_SIZE_LARGE         			000000100H
#Define PERF_SIZE_ZERO          			000000200H
#Define PERF_SIZE_VARIABLE_LEN  			000000300H

#Define PERF_TYPE_NUMBER        			000000000H
#Define PERF_TYPE_COUNTER       			000000400H
#Define PERF_TYPE_TEXT          			000000800H
#Define PERF_TYPE_ZERO          			000000C00H

#Define PERF_NUMBER_HEX         			000000000H
#Define PERF_NUMBER_DECIMAL     			000010000H
#Define PERF_NUMBER_DEC_1000    			000020000H

#Define PERF_COUNTER_VALUE      			000000000H
#Define PERF_COUNTER_RATE       			000010000H
#Define PERF_COUNTER_FRACTION   			000020000H
#Define PERF_COUNTER_BASE       			000030000H
#Define PERF_COUNTER_ELAPSED    			000040000H
#Define PERF_COUNTER_QUEUELEN   			000050000H
#Define PERF_COUNTER_HISTOGRAM  			000060000H

#Define PERF_TEXT_UNICODE       			000000000H
#Define PERF_TEXT_ASCII         			000010000H

#Define PERF_TIMER_TICK         			000000000H
#Define PERF_TIMER_100NS        			000100000H
#Define PERF_OBJECT_TIMER       			000200000H

#Define PERF_DELTA_COUNTER      			000400000H
#Define PERF_DELTA_BASE         			000800000H
#Define PERF_INVERSE_COUNTER    			001000000H
#Define PERF_MULTI_COUNTER      			002000000H

#Define PERF_DISPLAY_NO_SUFFIX  			000000000H
#Define PERF_DISPLAY_PER_SEC    			010000000H
#Define PERF_DISPLAY_PERCENT    			020000000H
#Define PERF_DISPLAY_SECONDS    			030000000H
#Define PERF_DISPLAY_NOSHOW     			040000000H

#Define PERF_COUNTER_COUNTER				(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_PER_SEC)
#Define PERF_COUNTER_TIMER          		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT)
#Define PERF_COUNTER_QUEUELEN_TYPE  		(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_QUEUELEN | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX)
#Define PERF_COUNTER_LARGE_QUEUELEN_TYPE	(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_QUEUELEN | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX)
#Define PERF_COUNTER_BULK_COUNT				(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_PER_SEC)
#Define PERF_COUNTER_TEXT           		(PERF_SIZE_VARIABLE_LEN | PERF_TYPE_TEXT | PERF_TEXT_UNICODE | PERF_DISPLAY_NO_SUFFIX)
#Define PERF_COUNTER_RAWCOUNT       		(PERF_SIZE_DWORD | PERF_TYPE_NUMBER | PERF_NUMBER_DECIMAL | PERF_DISPLAY_NO_SUFFIX)
#Define PERF_COUNTER_LARGE_RAWCOUNT       	(PERF_SIZE_LARGE | PERF_TYPE_NUMBER | PERF_NUMBER_DECIMAL | PERF_DISPLAY_NO_SUFFIX)
#Define PERF_COUNTER_RAWCOUNT_HEX       	(PERF_SIZE_DWORD | PERF_TYPE_NUMBER | PERF_NUMBER_HEX | PERF_DISPLAY_NO_SUFFIX)
#Define PERF_COUNTER_LARGE_RAWCOUNT_HEX		(PERF_SIZE_LARGE | PERF_TYPE_NUMBER | PERF_NUMBER_HEX | PERF_DISPLAY_NO_SUFFIX)

#Define PERF_SAMPLE_FRACTION        		(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DELTA_COUNTER | PERF_DELTA_BASE | PERF_DISPLAY_PERCENT)
#Define PERF_SAMPLE_COUNTER         		(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX)

#Define PERF_COUNTER_NODATA         		(PERF_SIZE_ZERO | PERF_DISPLAY_NOSHOW)
#Define PERF_COUNTER_TIMER_INV      		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT)

#Define PERF_SAMPLE_BASE            		(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_DISPLAY_NOSHOW | 000000001H)

#Define PERF_AVERAGE_TIMER          		(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DISPLAY_SECONDS)
#Define PERF_AVERAGE_BASE           		(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_DISPLAY_NOSHOW | 000000002H)
#Define PERF_AVERAGE_BULK           		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DISPLAY_NOSHOW)

#Define PERF_100NSEC_TIMER          		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT)
#Define PERF_100NSEC_TIMER_INV      		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_DELTA_COUNTER | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT)

#Define PERF_COUNTER_MULTI_TIMER    		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_DELTA_COUNTER | PERF_TIMER_TICK | PERF_MULTI_COUNTER | PERF_DISPLAY_PERCENT)
#Define PERF_COUNTER_MULTI_TIMER_INV		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_DELTA_COUNTER | PERF_MULTI_COUNTER | PERF_TIMER_TICK | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT)
#Define PERF_COUNTER_MULTI_BASE     		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_MULTI_COUNTER | PERF_DISPLAY_NOSHOW)

#Define PERF_100NSEC_MULTI_TIMER   			(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_DELTA_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_MULTI_COUNTER | PERF_DISPLAY_PERCENT)
#Define PERF_100NSEC_MULTI_TIMER_INV		(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_DELTA_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_MULTI_COUNTER | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT)

#Define PERF_RAW_FRACTION          			(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DISPLAY_PERCENT)
#Define PERF_RAW_BASE               		(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_DISPLAY_NOSHOW | 000000003H)

#Define PERF_ELAPSED_TIME					(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_ELAPSED | PERF_OBJECT_TIMER | PERF_DISPLAY_SECONDS)

#Define PERF_COUNTER_HISTOGRAM_TYPE   		080000000H
#Define PERF_COUNTER_DELTA					(PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_VALUE | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX)
#Define PERF_COUNTER_LARGE_DELTA			(PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_VALUE | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX)

#Define PERF_DETAIL_NOVICE          		100
#Define PERF_DETAIL_ADVANCED        		200
#Define PERF_DETAIL_EXPERT          		300
#Define PERF_DETAIL_WIZARD          		400

#Define PERF_NO_UNIQUE_ID 					(-1)

#Define PERF_QUERY_OBJECTS      			080000000H
#Define PERF_QUERY_GLOBAL       			080000001H
#Define PERF_QUERY_COSTLY       			080000002H

#Define MAX_PERF_OBJECTS_IN_QUERY_FUNCTION  8


PERF_DATA_BLOCK Struct
	Signature DW 4 Dup ?
	LittleEndian DD
	Version DD
	Revision DD
	TotalByteLength DD
	HeaderLength DD
	NumObjectTypes DD
	DefaultObject DD
	SystemTime SYSTEMTIME <>
	PerfTime LARGE_INTEGER <>
	PerfFreq LARGE_INTEGER <>
	PerfTime100nSec LARGE_INTEGER <>
	SystemNameLength DD
	SystemNameOffset DD
EndS

PERF_OBJECT_TYPE Struct
	TotalByteLength DD
	DefinitionLength DD
	HeaderLength DD
	ObjectNameTitleIndex DD
	ObjectNameTitle DD
	ObjectHelpTitleIndex DD
	ObjectHelpTitle DD
	DetailLevel DD
	NumCounters DD
	DefaultCounter DD
	NumInstances DD
	CodePage DD
	PerfTime LARGE_INTEGER <>
	PerfFreq LARGE_INTEGER <>
EndS

PERF_COUNTER_DEFINITION Struct
	ByteLength DD
	CounterNameTitleIndex DD
	CounterNameTitle DD
	CounterHelpTitleIndex DD
	CounterHelpTitle DD
	DefaultScale DD
	DetailLevel DD
	CounterType DD
	CounterSize DD
	CounterOffset DD
EndS

PERF_INSTANCE_DEFINITION Struct
	ByteLength DD
	ParentObjectTitleIndex DD
	ParentObjectInstance DD
	UniqueID DD
	NameOffset DD
	NameLength DD
EndS

PERF_COUNTER_BLOCK Struct
	ByteLength DD
EndS


#ENDIF ;WINPERF_INC
